/*
 *  arch/arm/mach-versatile/include/mach/system.h
 *
 *  Copyright (C) 2003 ARM Limited
 *  Copyright (C) 2000 Deep Blue Solutions Ltd
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __ASM_ARCH_SYSTEM_H
#define __ASM_ARCH_SYSTEM_H

#include <linux/io.h>
#include <mach/hardware.h>
#include <mach/platform.h>
#include <mach/powerman.h>

#define PM_RSTC_WRCFG_FULL_RESET	(0x00000020)

static inline void arch_idle(void)
{
	/*
	 * This should do all the clock switching
	 * and wait for interrupt tricks
	 */
	cpu_do_idle();
}

static inline void arch_reset(char mode, const char *cmd)
{
	uint32_t pm_rstc;
	uint32_t pm_audio;
	#define PM_RSTC_SRCFG_FULL 0x200


    // Enable software resets.
	pm_rstc = readl(IO_ADDRESS(PM_RSTC));
    pm_rstc = PM_PASSWORD | (pm_rstc & PM_RSTC_SRCFG_CLR) | PM_RSTC_SRCFG_FULL;
	writel(pm_rstc, IO_ADDRESS(PM_RSTC));

    // Now trigger a software reset.
	pm_audio = readl(IO_ADDRESS(PM_AUDIO));
	pm_audio = PM_PASSWORD | (pm_audio & PM_AUDIO_RSTN_CLR);
	writel(pm_audio, IO_ADDRESS(PM_AUDIO));
}

#endif
