#ifndef _OTP_H
#define _OTP_H

//#define OTP_DEBUG

#ifdef OTP_DEBUG

#ifdef __KERNEL__
#define refmt(fmt) "[%s]: " fmt, __func__
#define otp_print(fmt, ...) \
	printk(KERN_ERR refmt(fmt), ##__VA_ARGS__)
#else
#define refmt(fmt) "[%s]: " fmt, __func__
#define otp_print(fmt, ...) \
    printf(refmt(fmt), ##__VA_ARGS__)
#endif

#else
#define otp_print(fmt, ...)
#endif

void vc_otp_test(int test);
int vc_otp_read(uint32_t addr, uint32_t length, char __user *buf);
int vc_otp_write(uint32_t addr, uint32_t length, const char __user *buf);
int vc_otp_verify_results(uint32_t addr, uint32_t length, char __user *buf);

#endif
