/*=============================================================================
Copyright (c) 2007 Broadcom Europe Limited.
All rights reserved.

Project  :  vcfw
Module   :  ipc driver
File     :  $RCSfile: adc.h,v $
Revision :  $Revision: #1 $

FILE DESCRIPTION

=============================================================================*/

#ifndef OTP_REGS_H_
#define OTP_REGS_H_

// register: control
#define OTP_CONTROL_OFFSET                0x00

// bit numbers in control register
#define OTP_CONTROL_GO                    0x01
#define OTP_CONTROL_DONE                  0x02
#define OTP_CONTROL_READ                  0x04  // read if !=0, write if == 0
#define OTP_CONTROL_TEST                  0x08  // test mode (no writes) if == 1

// register: otp status               
#define OTP_STATUS_OFFSET                 0x10

// status bits
#define OTP_STATUS_NO_ERROR               0x00
#define OTP_STATUS_CRCERR                 0x01  // set if a crc error happened
#define OTP_STATUS_INVALID_PARAM          0x02  // set if invalid input parameters
#define OTP_STATUS_PERIPH_ERR             0x04  // OTP Periph failure

// register: length of data to write to otp
#define OTP_REQUEST_LENGTH_OFFSET         0x20

//register: otp address to read from or write to
#define OTP_ADDRESS_OFFSET                0x30

//CRC for every transfer                  
#define OTP_DATA_CRC                      0x40

// start offset of data in our buffer
#define OTP_REQUEST_DATA_OFFSET           0x50

// start offset of verify result bits
#define OTP_REQUEST_VERIFY_RESULTS_OFFSET 0xa0

// Max length in rows
#define OTP_MAX_ROWS					  4

// max buffer size
#define OTP_REQUEST_BUFFER_SIZE           4096

#define OTP_REGISTER_RW(offset) (*(volatile unsigned long *)(otp_state.base_address + offset))

#endif // OTP_REGS_H_
