
#ifndef _SERIAL_BCM2708_H
#define _SERIAL_BCM2708_H

#define UART_STATUS_REG		(UART1_BASE + 0x54)
#define UART_DATA			(UART1_BASE + 0x40)


#define UART_STATUS_TX_READY		(0x20)
#define UART_STATUS_RX_READY		(0x01)

#define VC_SYSTEM_CLOCK_FREQ		(250000000)

#define AUX_MU_EN_REG   (0x04)
#define AUX_MU_IO_REG   (0x40)
#define AUX_MU_IER_REG  (0x44)
#define AUX_MU_IIR_REG  (0x48)
#define AUX_MU_LCR_REG  (0x4C)
#define AUX_MU_MCR_REG  (0x50)
#define AUX_MU_LSR_REG  (0x54)
#define AUX_MU_MSR_REG  (0x58)
#define AUX_MU_SCRATCH  (0x5C)
#define AUX_MU_CNTL_REG (0x60)
#define AUX_MU_STAT_REG (0x64)
#define AUX_MU_BAUD     (0x68)

#define BIT_0           (0x00000001)
#define BIT_1           (0x00000002)
#define BIT_2           (0x00000004)
#define BIT_3           (0x00000008)
#define BIT_4           (0x00000010)
#define BIT_5           (0x00000020)
#define BIT_6           (0x00000040)
#define BIT_7           (0x00000080)
#define BIT_8           (0x00000100)
#define BIT_9           (0x00000200)
#define BIT_10          (0x00000400)
#define BIT_11          (0x00000800)
#define BIT_12          (0x000001000)
#define BIT_13          (0x000002000)
#define BIT_14          (0x000004000)
#define BIT_15          (0x000008000)

#endif //_SERIAL_BCM2708_H
