#! /bin/sh
mdev -s

if [ $# -ne 3 ]
then
    echo "Usage : . `basename $0` <ipadress> <nfsroot> <mountpoint>"
    echo "Where:"
    echo "<ipaddress> = ipaddress for usb0 interface"
    echo "<nfsroot> = <nfs server ip>:<path to nfs share>"
    echo "<mountpoint> = where to mount"
    echo "Example:"
    echo "nfsmount.sh 10.19.75.101 10.19.75.159:/srv/nfsbuildroot /system"
    exit 1;
fi

USB0_IP=$1
NFS_DEVICE=$2
NFS_MOUNT=$3

echo "bring up lo interface"
ifconfig lo up

echo "bring up usb0 interface ip address="$USB0_IP
ifconfig usb0 $USB0_IP up

echo "mounting NFS filesystem..."
echo "nfs server="$NFS_DEVICE 
echo "mount point="$NFS_MOUNT
mount -t nfs -onolock $NFS_DEVICE $NFS_MOUNT


echo "setting up nfs buildroot environment .."
# Buildroot environment setup
rm -r /lib
ln -s /$NFS_MOUNT/lib /lib
rm -r /usr
ln -s /$NFS_MOUNT/usr /usr
export PATH=$PATH:/$NFS_MOUNT/bin:/$NFS_MOUNT/sbin
export LD_LIBRARY_PATH=$NFS_MOUNT/lib:$LD_LIBRARY_PATH

echo "setting up buildroot environment .."
#QT environment setup
export QTDIR=/usr
export LD_LIBRARY_PATH=$QTDIR/lib:$LD_LIBRARY_PATH
export QT_QWS_FONTDIR=$QTDIR/lib/fonts
export QWS_DISPLAY="LinuxFb:/dev/fb0"
export QWS_MOUSE_PROTO="linuxinput:/dev/input/event1"

echo "Done ... !"
