/*=============================================================================
Copyright (c) 2007 Broadcom Europe Limited.
All rights reserved.

Project  :  vcfw
Module   :  ipc driver
File     :  $RCSfile: adc.h,v $
Revision :  $Revision: #1 $

FILE DESCRIPTION

=============================================================================*/

#ifndef AUDIO_REGS_H_
#define AUDIO_REGS_H_

//8 x 2k @ (44.1kh 2 channel) == 100ms of latency worst case
#define AUDIO_IPC_BLOCK_NUM_BUFFERS    8U
#define AUDIO_IPC_BLOCK_BUFFER_SIZE    (8U << 10)

#define AUDIO_CONTROL_OFFSET              0x00
#define AUDIO_STATUS_OFFSET               0x04
  // Bit definitions for control and status register bitwise OR as needed.
  #define AUDIO_CONTROL_ENABLE              (1 <<  0) // edge triggered
  #define AUDIO_CONTROL_SETUP               (1 <<  1) // level triggered
  #define AUDIO_CONTROL_PLAY                (1 <<  2) // edge triggered
  #define AUDIO_CONTROL_MUTE                (1 <<  3)
  #define AUDIO_CONTROL_FLUSH               (1 <<  4) // level triggered
  #define AUDIO_CONTROL_ERROR               (1 << 31)

#define AUDIO_DESTINATION_OFFSET          0x0C
   #define AUDIO_DESTINATION_LOCAL        (1 << 0)
   #define AUDIO_DESTINATION_HDMI         (1 << 1)
   #define AUDIO_DESTINATION_ALL          (AUDIO_DESTINATION_LOCAL | AUDIO_DESTINATION_HDMI)

#define AUDIO_SAMPLE_RATE_OFFSET          0x10
#define AUDIO_BIT_RATE_OFFSET             0x14
#define AUDIO_VOLUME_OFFSET               0x18
#define AUDIO_CHANNELS_OFFSET             0x1C

#define AUDIO_STOPFLUSH_OFFSET            0x20
#define AUDIO_AUDIOCLOCK_OFFSET           0x24


#define AUDIO_VIDEOCORE_TO_ARM_WRITE_PTR_OFFSET        0x30
#define AUDIO_VIDEOCORE_TO_ARM_READ_PTR_OFFSET         0x34
#define AUDIO_VIDEOCORE_TO_ARM_FIFO_SIZE_OFFSET        0x38
#define AUDIO_VIDEOCORE_TO_ARM_FIFO_ENTRY_OFFSET       0x3C
#define AUDIO_VIDEOCORE_TO_ARM_FIFO_START_OFFSET       0x40

//8 entries here of 4 words each = 0x80 gap from 0x50
#define AUDIO_VIDEOCORE_TO_ARM_FIFO_OFFSET             0x50

#define AUDIO_ARM_TO_VIDEOCORE_WRITE_PTR_OFFSET         0xD0
#define AUDIO_ARM_TO_VIDEOCORE_READ_PTR_OFFSET          0xD4
#define AUDIO_ARM_TO_VIDEOCORE_FIFO_SIZE_OFFSET         0xD8
#define AUDIO_ARM_TO_VIDEOCORE_FIFO_ENTRY_OFFSET        0xDC
#define AUDIO_ARM_TO_VIDEOCORE_FIFO_START_OFFSET        0xE0

//8 entries here of 4 words each = 0x80 gap from 0xF0
#define AUDIO_ARM_TO_VIDEOCORE_FIFO_OFFSET              0xF0

//this struct is tightly packet - its size is 16bytes
typedef struct
{
   uint32_t buffer_id;
   uint32_t buffer_size;
   uint32_t buffer_ptr;
   uint32_t spare;
} AUDIO_FIFO_ENTRY_T;


#endif // AUDIO_REGS_H_
